module JulienSluggable
  def self.included(base)
    base.send(:include, InstanceMethods)
    base.extend(ClassMethods)
    base.class_eval do
      commence_slugification
    end
  end

  module InstanceMethods
    def generate_slug
      slug = self.send(self.class::SLUG_BASE)
      slug = slug.gsub(' ', '_').gsub(/\W/, '').downcase

      unless self.class.find_by(slug: slug).nil?
        num = 1
        until self.class.find_by(slug: "#{slug}-#{num}").nil?
          num += 1
        end
        slug = "#{slug}-#{num}"
      end

      self.slug = slug
    end

    def to_param
      self.slug
    end
  end

  module ClassMethods
    def commence_slugification
      before_save :generate_slug
    end
  end
end